/***************************************************************************/
/*                                                                         */
/* FILE NAME : fitness.c                                                   */
/*                                                                         */
/*                                                                         */
/***************************************************************************/

#include "ga.h"

extern int nodecount, spop, besti;
extern double zs[MAX_POP];
extern double cost[MAX_POP];
extern int bstr[MAX_POP][MAX_ND], bestsol[MAX_ND];
extern double w[MAX_ND][MAX_ND];
extern float p[MAX_POP];

void rescale()
{
  double zmin, zmax;
  float maxprob, minprob;
  int i;

  maxprob = 1.2;
  minprob = 0.8;
  zmin = zmax = zs[0];
  besti = 0;
  for (i=1; i<spop; i++)
    {
      if (zs[i] > zmax) zmax = zs[i];
      if (zs[i] < zmin) {
	zmin = zs[i];
	besti = i;
      }
    }
  for (i=0; i<nodecount; i++) bestsol[i] = bstr[besti][i];
  
  for (i=0; i<spop; i++)
    p[i] = maxprob - ( (zs[i]-zmin)/(zmax-zmin) ) * (maxprob - minprob);
}


void rescaleProportionate() /* Fitness_proportionate repr. selec. */
{
  double zmin, zmax;
  float  average_fitness=0.0;
  int i;

  zmin = zmax = zs[0];
  besti = 0;
  for (i=1; i<spop; i++)
  {  average_fitness += 1.0/zs[i];
     if (zs[i] > zmax) zmax = zs[i];
     if (zs[i] < zmin) 
     {  zmin = zs[i];
	    besti = i;
     }
  }

  average_fitness = average_fitness/spop;

  for (i=0; i<nodecount; i++) bestsol[i] = bstr[besti][i];
  
  for (i=0; i<spop; i++)
    p[i] = 1.0/(zs[i]*average_fitness);

}/* rescaleProportionate()  */


double calc_fitness(xp)
int *xp;
{
  int j, k;
  double cons = 0;

  for (j = 0; j < nodecount; j++) {
    for (k = 0; k < nodecount; k++) {
      if (j != k)
	cons = cons - (w[j][k] * (*(xp+j)) * (*(xp+k)));
    }
    cons += w[j][j] * (*(xp+j));
  }

  return cons;
}/* end of calc_fitness() */


double my_calc_fitness(xp) /* JUNK */
int *xp;
{  int j, k;
   double cons = 0;

   for (j = 0; j < nodecount; j++) 
       for (k = 0; k < nodecount; k++) 
	     if ( (j != k) && (xp[j] != xp[k]) )
		cons = cons + w[j][k];
   return cons;
}/* end of my_calc_fitness() */

double calc_pop_fitness()
{
  int i, j, count0, count1;
  double avr = 0;

  for (i=0; i<spop; i++)
  {
     count0 = count1 =0;

     for (j=0; j<nodecount; j++) 
     {
	    if ( bstr[i][j] == 0) count0++;
	    else count1++;
     }

     zs[i] = calc_fitness(bstr[i]);
                /*  + (count0-count1)*(count0-count1);   */

     avr += zs[i];

  }/* end of for */

  return (avr/spop);

}/* end of calc_pop_fitness() */

